<?php
/**
 * Cobalt by MintJoomla
 * a component for Joomla! 1.7 - 3.x CMS (http://www.joomla.org)
 * Author Website: http://www.mintjoomla.com/
 * Module author Website: http://son-of-sky.com/
 * @copyright Copyright (C) 2014 Son of Sky (http://son-of-sky.com/). All rights reserved.
 * @license   GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die;

include_once JPATH_ROOT . '/components/com_cobalt/api.php';
include_once JPATH_ROOT . '/components/com_cobalt/library/php/helpers/helper.php';
$app = JFactory::getApplication();
$section = ItemsStore::getSection($params->get('section_id'));
$cat = ItemsStore::getCategory($params->get('catid'));

 if ($params->get('imagelink')) : 
 	 $inputimg = $params->get('imagelink');
 else: 
     $inputimg = 'modules/mod_cobalt_section/img/no-image.jpg';  
 endif;
 
 if ($params->get('resizetype')==5): // no resize img
   $outputimg = $inputimg;
 endif;
 if ($params->get('resizetype')==1||$params->get('resizetype')==2||$params->get('resizetype')==3||$params->get('resizetype')==4):	  
   $imgLink = str_replace("'","",$inputimg); // needed to remove the surrounding single-quote
   $thumb_url = str_ireplace('.','_mcs_thumb.',$imgLink);
   $img_width = $params->get('img_width',200);
   $img_height = $params->get('img_height',200);
   $orig_image = new JImage($inputimg);
   $w=$orig_image->getWidth()/$img_width;
   $h=$orig_image->getHeight()/$img_height;
    
       //switching resizing type
   	   switch ($params->get('resizetype')){
   	   	     case 1:
   	   	     $scale_method = JImage::SCALE_FILL;	 
   	   	     break;	 
             case 2:
             $scale_method = JImage::SCALE_OUTSIDE;
             break;
             case 3:
             $scale_method = JImage::SCALE_INSIDE;
             break;
       }
   $image_exists = false;
   if(file_exists($imgLink) && !file_exists($thumb_url)){ //if  thumb no exists
       // start cropping img
     if($params->get('resizetype')==4):          
   	   if($w < $h):
   	   $resized_image = $orig_image->resize($img_width,$img_height,false,JImage::SCALE_OUTSIDE);
   	   $cropped_image = $resized_image->crop($img_width, $img_height, 0, ($resized_image->getHeight()-$img_height)/2, true);
   	   endif;
   	   if($w > $h):
   	   $resized_image = $orig_image->resize($img_width,$img_height,false,JImage::SCALE_OUTSIDE);
   	   $cropped_image = $resized_image->crop($img_width, $img_height,($resized_image->getWidth()-$img_width)/2,0, true); 
   	   endif;
   	   if($w == $h):
   	   $cropped_image = $orig_image->resize($img_width,$img_height,true,JImage::SCALE_INSIDE);
   	   endif;   	   
   	   $cropped_image ->toFile($thumb_url);
   	   $image_exists = true;   	   
   	 endif;//end cropping  
   	   
      //start resizing   	   
   	  if ($params->get('resizetype')==1 || $params->get('resizetype')==2 || $params->get('resizetype')==3): 
      $resized_image = $orig_image->resize($img_width,$img_height,true,$scale_method);
      $resized_image->toFile($thumb_url);
      $image_exists = true;
      endif; //end resizing 
   }
   else{
      $image_exists = file_exists($thumb_url); //  if  thumb exists, but size not correct
      //start cropping
      if ($params->get('resizetype')==4):
      	  if ($w < $h):      	   
      	  $resized_image_fake = $orig_image->resize($img_width,$img_height,false,JImage::SCALE_OUTSIDE);
          $cropped_image_fake = $resized_image_fake->crop($img_width, $img_height,0,($resized_image_fake->getHeight()-$img_height)/2, false);    
          endif;
          if ($w > $h):      	   
      	  $resized_image_fake = $orig_image->resize($img_width,$img_height,false,JImage::SCALE_OUTSIDE);
          $cropped_image_fake = $resized_image_fake->crop($img_width, $img_height,($resized_image_fake->getWidth()-$img_width)/2,0, false);   
          endif;
          if ($w == $h):      	   
      	  $cropped_image_fake = $orig_image->resize($img_width,$img_height,false,JImage::SCALE_INSIDE);   
          endif; 
      	  $old_thumb = new JImage($thumb_url); 
      	  // compare real thumb with virtual(changed)
      	  if ($old_thumb->getWidth()!=$cropped_image_fake->getWidth() || $old_thumb->getHeight()!=$cropped_image_fake->getHeight()):
      	   	   if ($w < h):
      	   	   $resized_image_fake = $orig_image->resize($img_width,$img_height,false,JImage::SCALE_OUTSIDE);
      	   	   $cropped_image = $resized_image_fake->crop($img_width, $img_height,0,($resized_image_fake->getHeight()-$img_height)/ 2, true);    
               endif;
               if ($w > h):      	   
      	       $resized_image_fake = $orig_image->resize($img_width,$img_height,false,JImage::SCALE_OUTSIDE);
               $cropped_image = $resized_image_fake->crop($img_width, $img_height,($resized_image_fake->getWidth()-$img_width)/2,0, true);  
               endif;
               if ($w == $h):      	   
      	       $cropped_image = $orig_image->resize($img_width,$img_height,true,JImage::SCALE_INSIDE);   
               endif;               
      	  $cropped_image->toFile($thumb_url);
      	  $image_exists = true;
      	  endif;      	        
      endif; //end cropping          
      //start resizing
      if ($params->get('resizetype')==1 || $params->get('resizetype')==2 || $params->get('resizetype')==3):      	   
      	  $resized_image_fake = $orig_image->resize($img_width,$img_height,false,$scale_method);      
      	  $old_thumb = new JImage($thumb_url);
      	  // compare real thumb with virtual(changed)
      	  if ($old_thumb->getWidth()!=$resized_image_fake->getWidth() || $old_thumb->getHeight()!=$resized_image_fake->getHeight()):
      	  $resized_image = $orig_image->resize($img_width,$img_height,true,$scale_method);
      	  $resized_image->toFile($thumb_url);
      	  $image_exists = true;
      	  endif;      
      endif; //end resizing 
   }
  $outputimg = $thumb_url;
 endif;
 
if( $params->get('change_item_id','1')==0){   //overwrite menu item
			$menu_item_id = '&Itemid='.$params->get('menu_item_id');
		}
		 else if ( $params->get('showtitle')==1){
			$menu_item_id = '';
 } 
 		
switch($params->get('moduletype'))
{
	case 1:
		$outputlink = 'index.php?option=com_cobalt&view=records&section_id='.$section->id.$menu_item_id;
		if( $params->get('showtitle')==2){
			$outputtitle = $params->get('s_title');
		}
		 else if ( $params->get('showtitle')==1){
			$outputtitle = $section->title;
 		}
		if( $params->get('showdesc')==2){
			$outputdesc = $params->get('desc_text');
		}
		 else if( $params->get('showdesc')==1){
			$outputdesc = $section->description;
	 	}
  	 break;
	case 0:
		$outputlink = 'index.php?option=com_cobalt&view=records&section_id='.$section->id.'&cat_id='.$params->get('catid').$menu_item_id;
		if( $params->get('showtitle')==2){
			$outputtitle = $params->get('s_title');
		}
		 else if ( $params->get('showtitle')==1){
			$outputtitle = $cat->title;
 		}
		if( $params->get('showdesc')==2){
			$outputdesc = $params->get('desc_text');
		}
		else if( $params->get('showdesc')==1){
			$outputdesc = $cat->description;
 		}
	 break;
}
	
require JModuleHelper::getLayoutPath('mod_cobalt_section', $params->get('layout', 'default'));